import { ChartD3Service } from '../../services/chart.d3.service';
export class ColumnSeries {
    dataHandler() {
        this.anjColumnDidLoad.emit();
    }
    componentDidLoad() {
        this.anjColumnDidLoad.emit();
    }
    async init(svg, x, x1, y, data, index, dims) {
        this.color = this.color || ChartD3Service.colors[index || 0];
        const bars = ChartD3Service.addColumn(svg, x, x1, y, data, this.color, dims, index);
        return Promise.resolve(bars);
    }
    static get is() { return "anj-column-series"; }
    static get properties() { return {
        "color": {
            "type": String,
            "attr": "color",
            "mutable": true
        },
        "data": {
            "type": "Any",
            "attr": "data",
            "watchCallbacks": ["dataHandler"]
        },
        "element": {
            "elementRef": true
        },
        "init": {
            "method": true
        },
        "name": {
            "type": String,
            "attr": "name"
        },
        "netNegative": {
            "type": Boolean,
            "attr": "net-negative"
        }
    }; }
    static get events() { return [{
            "name": "anjColumnDidLoad",
            "method": "anjColumnDidLoad",
            "bubbles": true,
            "cancelable": true,
            "composed": true
        }]; }
}
