import { ChartD3Service } from '../../services/chart.d3.service';
export class LineSeries {
    dataHandler() {
        this.anjLineDidLoad.emit();
    }
    componentDidLoad() {
        this.anjLineDidLoad.emit();
    }
    async init(svg, x, y, data, index, dims, multiSeries, secondaryIndex) {
        this.color = this.color || ChartD3Service.colors[secondaryIndex || index || 0];
        const line = ChartD3Service.addLine(svg, x, y, data, this.color);
        const allPositive = (data) ? Math.min(...data.map(d => Number(d.y))) >= 0 : true;
        if (multiSeries) {
            ChartD3Service.addScrubbers(svg, x, data, dims, index);
        }
        else if (allPositive) {
            ChartD3Service.addArea(svg, line, y, data, this.color);
        }
        ChartD3Service.addPoints(svg, x, y, data, this.color, index);
        return Promise.resolve(this.color);
    }
    static get is() { return "anj-line-series"; }
    static get properties() { return {
        "color": {
            "type": String,
            "attr": "color",
            "mutable": true
        },
        "data": {
            "type": "Any",
            "attr": "data",
            "watchCallbacks": ["dataHandler"]
        },
        "element": {
            "elementRef": true
        },
        "init": {
            "method": true
        },
        "name": {
            "type": String,
            "attr": "name"
        },
        "netNegative": {
            "type": Boolean,
            "attr": "net-negative"
        }
    }; }
    static get events() { return [{
            "name": "anjLineDidLoad",
            "method": "anjLineDidLoad",
            "bubbles": true,
            "cancelable": true,
            "composed": true
        }]; }
}
